# mongoc_client_get_database_names()

## Synopsis

    char **
    mongoc_client_get_database_names (mongoc_client_t *client, bson_error_t *error);

## Deprecated

This function is deprecated and should not be used in new code.

Please use mongoc_client_get_database_names_with_opts() instead.

## Description

This function queries the MongoDB server for a list of known databases.

This function is considered a retryable read operation. Upon a transient error (a network error, errors due to replica set failover, etc.) the operation is safely retried once. If `retryreads` is false in the URI (see mongoc_uri_t) the retry behavior does not apply.

## Parameters

- `client`: A mongoc_client_t.
- `error`: An optional location for a bson_error_t or `NULL`.

## Errors

Errors are propagated via the `error` parameter.

## Returns

A `NULL` terminated vector of `NULL-byte` terminated strings. The result should be freed with `bson_strfreev()`.

`NULL` is returned upon failure and `error` is set.